To the Max
http://poj.org/problem?id=1050
Description
Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. In this problem the sub-rectangle with the largest sum is referred to as the maximal sub-rectangle.
As an example, the maximal sub-rectangle of the array:
0 -2 -7 0
9 2 -6 2
-4 1 -4 1
-1 8 0 -2
is in the lower left corner:
9 2
-4 1
-1 8
and has a sum of 15.
Input
The input consists of an N * N array of integers. The input begins with a single positive integer N on a line by itself, indicating the size of the square two-dimensional array. This is followed by N^2 integers separated by whitespace (spaces and newlines). These are the N^2 integers of the array, presented in row-major order. That is, all numbers in the first row, left to right, then all numbers in the second row, left to right, etc. N may be as large as 100. The numbers in the array will be in the range [-127,127].
Output
Output
the sum of the maximal sub-rectangle.
Sample Input
4
0 -2 -7 0 9 2 -6 2
-4 1 -4 1 -1
8 0 -2
Sample Output
15
解题思路
本题是典型的动态规划,实际是求矩阵的最大子矩阵(和最大)。这是将序列的连续最大段和问题扩展到二维的一题。
序列的最大连续段和问题思路:
原序列a 0 -2 -7 0 9 2 -6 2
记录 b 0 0 0 0 9 11 5 7
结果为11
将这个问题扩展到二维,则先将选中的几行,逐列相加变为一个一维数组。(如果是一行的情况,则直接使用序列的最大连续段和方法)
多行变为一行时:例如
0 -2 -7 0
9 2 -6 2
-4 1 -4 1
-1 8 0 -2
当i=0, j=2时,则选择0,1,2行
0 -2 -7 0
9 2 -6 2
-4 1 -4 1
a: 5 1 -17 3
b: 5 6 0 3
答案为3
参考
http://blog.csdn.net/jqandjq/article/details/5060283
#include <stdio.h> #include <stdlib.h> int main (int argc, char const* argv[]) { int i, j, k, l, n, ans, sum, max; int a[100][100]; int b[100]; scanf("%d", &n); for (i = 0; i < n; i++) { for (j = 0; j < n; j++) { scanf("%d", &a[i][j]); } } ans = 0; for (i = 0; i < n; i++) { for (j = 0; j < n; j++) { if (i == j) { for (k = 0; k < n; k++) { b[k] = a[i][k]; } } else { for (k = 0; k < n; k++) { b[k] = 0; for (l = i; l <= j; l++) { b[k] += a[l][k]; } } } sum = 0; max = 0; for (k = 0; k < n; k++) { sum += b[k]; if (sum > max) { max = sum; } if (sum < 0) { sum = 0; } } if (max > ans) { ans = max; } } } printf("%d\n", ans); return 0; }
发表评论
-
fhloj1051 投票
2013-07-04 19:42 0投票 源文件: b(.bas/.c/.cpp/.pas) 输 ... -
fhloj1050 足球赛
2013-07-04 19:36 613足球赛 源文件: a(.bas/.c/.cpp/.pas) ... -
fhloj1092 五子棋
2013-07-04 12:01 748五子棋 源文件: gobang(.bas/.c/.cpp/ ... -
fhloj1091 拼单词
2013-07-04 11:53 760拼单词 源文件: words ... -
fhloj1090 21点游戏
2013-07-04 11:44 65121点游戏 源文件: poker(.bas/.c/.cpp ... -
fhloj1089 帮奶奶算帐
2013-07-04 11:17 619帮奶奶算账 源代码:bill.bas/pas 输入文件:bil ... -
hdu1019 gcd和lcm
2012-12-06 15:09 838Least Common Multiple http://a ... -
hdu1021 推理规律
2012-12-06 09:24 947Fibonacci Again http://acm.hdu ... -
hud1008 电梯 迭代模拟计算
2012-12-04 18:24 1055Elevator http://acm.hdu.edu.cn ... -
hdu1001 求和
2012-12-03 22:05 800Sum Problem http://acm.hdu.edu ... -
hdu1000 A+B
2012-12-03 18:37 887A + B Problem http://acm.hdu.e ... -
hdu2035 乘方取余
2012-12-02 18:02 1185人见人爱A^B http://acm.hdu.edu.cn/ ... -
hdu2034 差集
2012-12-02 17:43 876人见人爱A-B http://acm.hdu.edu.cn/ ... -
hdu2033 时间计算
2012-12-02 16:24 924人见人爱A+B http://acm.hdu.edu.cn/ ... -
HDU1003最大连续子序列和
2012-12-01 15:08 1458Max Sum http://acm.hdu.edu.cn/ ... -
hdu2081 字符串拼接
2012-12-01 14:35 880手机短号 http://acm.hdu.edu.cn/sho ... -
poj1163 树型结构动态规划和最大路径
2012-11-30 22:05 1211The Triangle http://poj.org/pr ... -
POJ1579递归函数定义
2012-11-30 21:58 877Function Run Fun http://poj.or ...
相关推荐
poj online judge 1050 最大子矩阵动态规划解决
如果存在一个包含最大子矩阵P的更大子矩阵B,那么B中一定包含了另一个最大子矩阵P',这与P已经是最大子矩阵相矛盾,因此可以断定P就是所有包含它的子矩阵中元素和最大的。此外,该问题还具备子问题无关性和子问题...
POJ 1195题目要求我们计算一个二维矩阵中的子矩阵之和。这正是二维树状数组的优势所在,因为我们可以快速地对矩阵的任意矩形区域进行累加操作。下面我们将详细讲解二维树状数组的工作原理以及如何使用它来解决这个...
例如,对于矩阵乘积的最大化,可以尝试每次选取两个子矩阵,使得它们的乘积最大,然后合并这两个子矩阵,重复此过程,直到所有元素都被选取。 【递归】 递归是解决问题的一种常见方法,它通过调用自身来解决更小...
这道题目要求我们找到一个给定矩阵中的最大子矩阵和。这道题目可以使用动态规划来解决。我们可以使用 Kadane's algorithm 来解决这个问题,该算法可以在 O(n^3) 的时间复杂度内解决问题。 第 13 题:poj1088 滑雪 ...
对于矩阵中的每个元素,可以通过二维树状数组在常数时间内完成子矩阵的求和操作,从而高效地处理矩阵的各种操作。 3. POJ2299【基础】: 这道题目要求求解序列中进行多少次交换操作才能将其升序排列。逆序对的数量...